from setuptools import setup, find_packages

setup(
    name="streamingcommunity-film-downloader",  # Nome del pacchetto
    version="1.0.0",                           # Versione
    packages=find_packages(),                  # Trova tutte le cartelle contenenti codice
    install_requires=[                         # Dipendenze necessarie
        "requests",
        "yt-dlp",
        "beautifulsoup4",                      # Per usare BeautifulSoup
        "scuapi",                              # Per l'API di StreamingCommunity
        "StreamingCommunity",                   # Aggiunta la libreria per StreamingCommunity
    ],
    entry_points={                              # Permette di eseguire lo script da riga di comando
        'console_scripts': [
            'streamingcommunity-film-downloader=streamingcommunity_film_downloader.downloader:main',  # punto di ingresso
        ],
    },
    author="GliderAi",                         # Il tuo nome
    author_email="glidergit@gmail.com",      # La tua email
    description="Uno script per scaricare film da StreamingCommunity",  # Descrizione breve
    long_description=open('README.md').read(),  # Descrizione lunga (dal README.md)
    long_description_content_type='text/markdown',
    url="https://github.com/glideraiscript/streamingcommunity-film-downloader",  # URL del progetto su GitHub
    classifiers=[                             # Classificatori per PyPI
        "Programming Language :: Python :: 3",
        "License :: OSI Approved :: MIT License",
        "Operating System :: OS Independent",
    ],
    python_requires='>=3.6',                  # Specifica la versione minima di Python
)
